package com.cmeeting.controller;

import com.cmeeting.pojo.WeComUser;
import com.cmeeting.service.WeComService;
import com.google.gson.Gson;
import com.google.gson.JsonArray;
import com.google.gson.JsonElement;
import com.google.gson.JsonObject;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import java.io.BufferedReader;
import java.io.InputStreamReader;
import java.net.HttpURLConnection;
import java.net.URL;
import java.util.ArrayList;
import java.util.List;

import static com.cmeeting.WeComAndTencentMeeting.*;

@RestController
@RequestMapping("/wecom")
public class WeComcontroller {
    private static final String BASE_URL = "https://qyapi.weixin.qq.com/cgi-bin/user/simplelist";
    private static final String ACCESS_TOKEN = "wyYAmCbeVIPvj_Gpdd8ixp_td_hPv2OtTU8gpTGSpB7TaftbpNps5fc_JdCRzpgy_tUv-aGueJpRV6XJeYAG-rqkzCfDV-rcpJbqB0LypjvJUtxPeTmPqEtQuCMwH6euGGVaJZXoc33ATrS70U0T4_4WIrATqpsN2Ed2XsNGyN5N6aG8mq6AyLMG9TokVWx1qd2qF1zVTwve6aqRMWHwXg";
    @Autowired
    private WeComService weComService;

    @GetMapping("/add")
    public void addUsers() throws Exception {
        dousers();
    }

    public void dousers() throws Exception {
        // 示例：获取部门ID为6的用户列表
        int departmentId = 6;
        JsonObject result = getUserListByDepartment(departmentId);
        // 处理返回结果
        if (result.get("errcode").getAsInt() == 0) {
            System.out.println("企微获取用户列表成功：");
            JsonArray userList = result.getAsJsonArray("userlist");
            for (int i = 0; i < userList.size(); i++) {
                JsonObject user = userList.get(i).getAsJsonObject();
                System.out.println("姓名: " + user.get("name").getAsString() +
                        ", UserID: " + user.get("userid").getAsString());
            }
            // 2. 转换为WeComUser集合
            List<WeComUser> users = convertJsonToWeComUsers(result);
            // 3. 检查重名并设置标志
            markDuplicateNames(users);

            // 4. 批量插入数据库
            weComService.batchInsert(users);
        }

    }

    /**
     * 根据企业微信部门ID获取用户列表
     *
     * @param departmentId 部门ID
     * @return 包含用户列表的JsonObject
     * @throws Exception
     */
    public static JsonObject getUserListByDepartment(int departmentId) throws Exception {
        String urlStr = BASE_URL + "?access_token=" + ACCESS_TOKEN + "&department_id=" + departmentId;

        URL url = new URL(urlStr);
        HttpURLConnection conn = (HttpURLConnection) url.openConnection();
        conn.setRequestMethod("GET");

        int responseCode = conn.getResponseCode();
        if (responseCode == HttpURLConnection.HTTP_OK) {
            BufferedReader in = new BufferedReader(new InputStreamReader(conn.getInputStream()));
            String inputLine;
            StringBuilder response = new StringBuilder();

            while ((inputLine = in.readLine()) != null) {
                response.append(inputLine);
            }
            in.close();

            // 使用Gson解析JSON响应
            Gson gson = new Gson();
            return gson.fromJson(response.toString(), JsonObject.class);
        } else {
            throw new RuntimeException("HTTP GET请求失败，错误码: " + responseCode);
        }
    }


}